var _ = require('underscore')._,
events = require('events'),
Hacktor = function Hacktor(object) {
    var postman = new events.EventEmitter(),
    mailbox = [],
    that = this,
    go = true,
    monitor = function monitor() {
        var data = mailbox.shift();
        if (data) {
            _.defer(function () {
                that.act(data);
            });
        }
        
        if (go || (!go && mailbox.length > 0)) {
            _.defer(monitor);
        } else if (!go && mailbox.length === 0) {
            postman.removeAllListeners('message');
        }
    };

    this.send = function send() {
        var args, data_obj, success = true;
        // only add message to mailbox if the actor is alive
        if (go) {
            args = _.toArray(arguments);
            data_obj = {
            message: args.shift(),
                context: {
                    args: args
                }
            };
            
            // if the last argument is a hacktor, make it the sender
            if (_.last(args) instanceof Hacktor) {
                data_obj.context.sender = args.pop()
                // if the caller is a hacktor, make it the sender
            } else if (send.caller.actor && send.caller.actor instanceof Hacktor) {
                data_obj.context.sender = send.caller.actor;
            }
        
            //add message to queue if the method can be called
            if (this[data_obj.message] && _.isFunction(this[data_obj.message])) {
                postman.emit('message', data_obj);
            } else {
                success = false;
            }
            
        } else {
            success = false;
        }
        return success;
    };

    this.act = function act(data) {
        if (this[data.message] && _.isFunction(this[data.message])) {
            this[data.message].apply(this, [data.context]);
        } 
    };

    this.spawn = function spawn() {
        return _.clone(this);
    };

    this.destroy = function destroy(immediate) {
        go = false;
        if (immediate) {
            mailbox = [];
            postman.removeAllListeners('message');
        }
    };

    _.extend(this, object);

    _(this).map( function (val, key) {
        if (_.isFunction(val)) {
            val.actor = that;
        }
    });

    postman.on('message', function (data) {
        mailbox.push(data);
    });

    _.defer(monitor);

    return this;
};

this.Hacktor = Hacktor;
